# Contributor Covenant Code of Conduct

## Our Pledge

In the interest of fostering an open and free environment, we as
contributors and maintainers pledge to making participation in our project and
our community a censorship-free experience for everyone, regardless of age, body
size, disability, ethnicity, gender identity and expression, level of experience,
education, socio-economic status, nationality, personal appearance, race,
religion, or sexual identity and orientation.

## Our Standards

Examples of behavior that contributes to creating an open and free environment
include:

* Not constraining the language to be "welcoming" or "inclusive"
* Not demanding show of empathy towards other community members
* Not dictating anyone to be respectful of differing viewpoints and experiences
* Not forcing anyone to change their views or opinions regardless of those
* Not intimidating other people into accepting your own views or opinions
* Not blackmailing other people to disclose their personal views or opinions
* Not constraining other people from publishing their personal views or opinions in an unintrusive way
* Focusing on what is best for the ecosystem

Examples of acceptable behavior by participants include:

* The use of sexualized language
* Occasional trolling or insulting comments that are not completely off-topic

Examples of unacceptable behavior by participants include:

* Publishing others' private information, such as a physical or electronic address, without explicit permission
* Unwelcome sexual attention or advances
* Public harassment or personal attacks when carried out in an bold or intrusive way
* Private harassment
* Any actions that are in violation of the local laws or otherwise considered illegal
* Other conduct which could reasonably be considered inappropriate in an open and free setting

## Our Responsibilities

Project maintainers are responsible for clarifying the standards of acceptable
behavior and are free to take appropriate and fair corrective action in
response to any instances of unacceptable behavior.

Project maintainers have the right and authority to remove, edit, or
reject comments, commits, code, wiki edits, issues, and other contributions
that are not aligned to this Code of Conduct, or to ban temporarily or
permanently any contributor for other behaviors that they deem inappropriate,
threatening, offensive, or harmful.

## Scope

This Code of Conduct applies both within project spaces and in public spaces
when an individual is representing the project or its community. Examples of
representing a project or community include using an official project e-mail
address, posting via an official social media account, or acting as an appointed
representative at an online or offline event. Representation of a project may be
further defined and clarified by project maintainers.

## Enforcement

Instances of unacceptable behavior may be reported by contacting the project team.
The complaints will likely be reviewed and investigated and may result in a response that
is deemed necessary and appropriate to the circumstances. The project team should maintain confidentiality with regard to the reporter of an incident.
Further details of specific enforcement policies may be posted separately.

Project maintainers who do not follow the Code of Conduct in good
faith may face temporary or permanent repercussions as determined by other
members of the project's leadership.

## Attribution

This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4,
available at https://www.contributor-covenant.org/version/1/4/code-of-conduct.html

[homepage]: https://www.contributor-covenant.org

